// C Source File
// Created 01.12.2005; 21:19:12

 /********************************************************************************
 ********************************************************************************
 * Programm name:		thedb - The handy education database
 * File name:				ShowVarLink.c
 * Function name:		ShowVarLink
 * Header file:			---
 * Other functions:
 *	- CALLBACK VarLinkHandler
 *
 * Short Description: Show the Var-Link dialog and let the user select an entry.
 *										The path of the selected file will be stored in VarBuffer (global.h)
 *
 * Description:
 *	-
 *
 ********************************************************************************
 *********************************************************************************/


#include <tigcclib.h>

#include "structures.h"
#include "calc.h"
#include "global.h"



CALLBACK void VarLinkHandler (EVENT *ev)
{
  if (ev->Type == CM_HSTRING)
    {
      strncpy (VarBuffer, HeapDeref (ev->extra.hPasteText), 19);
      VarBuffer[19] = 0;
    }

  EV_defaultHandler (ev);
}

void ShowVarLink (void)
{
  EVENT ev;
  EVENT_HANDLER OldHandler = EV_captureEvents (VarLinkHandler);

  memset (&ev, sizeof (ev), 0);
  ev.Type = CM_KEYPRESS;
  ev.extra.Key.Code = KEY_VARLNK;
  EV_defaultHandler (&ev);
  EV_captureEvents (OldHandler);


  return;
}





