// C Source File
// Created 26.02.2006; 01:37:55

 /********************************************************************************
 ********************************************************************************
 * Programm name:		thedb - The handy education database
 * File name:				check_file_validity.c
 * Function name:		check_file_validity
 * Header file:			---
 * Other functions:
 *	-
 *
 * Short Description: Check the file for several attributes to make shure the
 *										file is valid
 *
 * Description:
 *	-
 *
 ********************************************************************************
 *********************************************************************************/

#include <tigcclib.h>
#include "fmanage.h"

#include "structures.h"
#include "global.h"
#include "main_menu.h"

int check_file_validity (CONFSTRUCT *confstruct, const char *filename, int option)
{
	FILE *datafile = NULL;
	char ext[5] = {0};

	//If the path name is the default string, return
	if (strstr(ActivePath, STR_NO_FILE_SEL) != NULL)
		{
			if (option == 1)
				DlgMessage("thedb[39]", "No file selected!", BT_OK, BT_NONE);
			return 0;
		}

	//------------------------------------------------------------------------------------------------------------------
	//Check if you try to open the backup file
	if (strstr(filename, BACKUPFILE_NAME) != NULL)
		{
			if (option == 1)
				DlgMessage("thedb[43]", "This is the backupfile!\nYou can't use it. Rename it first.", BT_OK, BT_NONE);
			return 0;
		}

	//------------------------------------------------------------------------------------------------------------------
	//Check file extension
	if ((FType(filename, ext)) == FS_BAD_NAME)
		{
			if (option == 1)
				DlgMessage("thedb[38]", "Invalid filepath!", BT_OK, BT_NONE);
			return 0;
		}

	switch (confstruct->ActiveForm)
		{
			case FORM_FORMULA:
					//If the file extension is the wrong one for formula files
					if (strcmp(ext, FILE_FORMULA_EXTENSION) != 0)
						{
							if (option == 1)
								DlgMessage("thedb[15]", "Illegal file extension!", BT_OK, BT_NONE);
							return 0;
						}
				break;
			case FORM_TEXT:
					//If the file extension is the wrong one for text files
					if (strcmp(ext, FILE_TEXT_EXTENSION) != 0)
						{
							if (option == 1)
								DlgMessage("thedb[16]", "Illegal file extension!", BT_OK, BT_NONE);
							return 0;
						}
				break;
			default:
				break;
		}

	//------------------------------------------------------------------------------------------------------------------
	//Check file version

	if ((datafile = fopen(ActivePath, "rb")) == NULL)
		{
			if (option == 1)
				DlgMessage("thedb[17]", "Failed to open!", BT_OK, BT_NONE);
			return 0;
		}

	switch (confstruct->ActiveForm)
		{
			char str[200] = {0};
			int FileVersion = 0;

			case FORM_FORMULA:
					if ((FileVersion = fmanage(&datafile, NULL, 0, NULL, NULL, 0, 0, FMF_RETURN_FINFO, FMF_RETURN_FV)) != FMF_FORMULA_FILE_VERSION)
						{
							sprintf(str, "Formula file with V. %d!\n"
														"This version of thdb uses V. %d.\n"
														"Use ThedbCnv to convert it.", FileVersion, FMF_FORMULA_FILE_VERSION);
							if (option == 1)
								DlgMessage("thedb[18]", str, BT_OK, BT_NONE);
							return 0;
						}
				break;
			case FORM_TEXT:
					if ((FileVersion = fmanage(&datafile, NULL, 0, NULL, NULL, 0, 0, FMF_RETURN_FINFO, FMF_RETURN_FV)) != FMF_TEXT_FILE_VERSION)
						{
							sprintf(str, "Text file with V. %d!\n"
														"This version of thdb uses V. %d.\n"
														"Use ThedbCnv to convert it.", FileVersion, FMF_TEXT_FILE_VERSION);
							if (option == 1)
								DlgMessage("thedb[19]", str, BT_OK, BT_NONE);
							return 0;
						}
				break;
			default:
				break;
		}

	//------------------------------------------------------------------------------------------------------------------
	fclose(datafile);

	return 1;

/*
char str[50] = {0};
	unsigned short size;
	ESQ type;
	SYM_ENTRY *sym;

	sym = SymFindPtr (SYMSTR (filename), 0);

	size = ((MULTI_EXPR*) HeapDeref (sym->handle))->Size + 2;
	type = *(HToESI (sym->handle));

sprintf(str, "name: %s\nsize: %d\n type: %d\n", sym->name, size, type);
DlgMessage("", str, BT_OK, BT_NONE);
*/



	//DlgMessage("", "", BT_OK, BT_NONE);


}