// C Source File
// Created 06.03.2006; 17:00:25

 /********************************************************************************
 ********************************************************************************
 * Programm name:		thedb - The handy education database
 * File name:				copy_to_clipboard.c
 * Function name:		copy_to_clipboard
 * Header file:			---
 * Other functions:
 *	-
 *
 * Short Description: Load the selected entry and copy it into the clipboard
 *
 * Description:
 *	-
 *
 ********************************************************************************
 *********************************************************************************/

#include <tigcclib.h>
#include "fmanage.h"

#include "structures.h"
#include "global.h"
#include "calc.h"

void copy_to_clipboard (CONFSTRUCT *confstruct, int datanr, const char *CopyToClipboardStr)
{
	FILE *datafile = NULL;	//The file pointer that handles the data file
	FORMULADATA formuladata;
	TEXTDATA textdata;
	char copystr[SOLVE_STRING_SIZE] = {0};
	char str[SOLVE_STRING_SIZE + 30] = {0};

	//Copy data to the clipboard

	GrayOff();
	clrscr();

	if (datanr != 0)
		{
			switch (confstruct->ActiveForm)
				{
					case FORM_FORMULA:
						//Open file and load data
						fmanage(&datafile, ActivePath, FMF_FORMULA_FILE_VERSION, FILE_FORMULA_EXTENSION, &formuladata, sizeof(FORMULADATA), datanr, FMF_NEW_FILE, FMF_NEW_NO_OVERWR);
						fmanage(&datafile, ActivePath, FMF_FORMULA_FILE_VERSION, FILE_FORMULA_EXTENSION, &formuladata, sizeof(FORMULADATA), datanr, FMF_LOAD, 0);
							switch (confstruct->ActiveList)
								{
									case FORMULA:
											strcpy(copystr, formuladata.formula);
										break;
									case DESC:
											strcpy(copystr, formuladata.desc);
										break;
									default:	//NAME
											strcpy(copystr, formuladata.name);
										break;
								}
						break;
					case FORM_TEXT:
						//Open file and load data
						fmanage(&datafile, ActivePath, FMF_TEXT_FILE_VERSION, FILE_TEXT_EXTENSION, &textdata, sizeof(TEXTDATA), datanr, FMF_NEW_FILE, FMF_NEW_NO_OVERWR);
						fmanage(&datafile, ActivePath, FMF_TEXT_FILE_VERSION, FILE_TEXT_EXTENSION, &textdata, sizeof(TEXTDATA), datanr, FMF_LOAD, 0);
							switch (confstruct->ActiveList)
								{
									case TEXT:
											strcpy(copystr, textdata.text);
										break;
									default:	//TITLE
											strcpy(copystr, textdata.title);
										break;
								}
						break;
					default:
						break;
				}
		}
	else
		{
			strcpy(copystr, CopyToClipboardStr);
		}


		if ((CB_replaceTEXT (copystr, strlen(copystr), TRUE)) == TRUE)
			sprintf (str, "Copyed\n\"%s\"\ninto clipboard.", copystr);
		else
			sprintf(str, "Failed to copy into clipboard!");

		DlgMessage ("Clipboard" , str, BT_OK, BT_NONE);




	return;
}