// Header File
// Created 16.02.2006; 21:22:11

 /********************************************************************************
 ********************************************************************************
 * Programm name:		thedb - The handy education database
 * File name:				global.h
 *
 * Short Description: This header file will be included in most of the source files.
 *										It contains definitions, variables and functions usable
 *										from everywhere.
 *
 * Description:
 *	-
 *
 ********************************************************************************
 *********************************************************************************/

//#define THDB_DEBUG
//#define THDB_AUTOSAVE
//#define THDB_AUTOSAVE_NUMBER		10



//-------------------------------------------
//File versions
#define	FMF_CONF_FILE_VERSION				3
#define FMF_FORMULA_FILE_VERSION		2
#define FMF_TEXT_FILE_VERSION				1
//other version tings
#define COMMENT_STRING         "by Thomas Naeff"
#define COMMENT_PROGRAM_NAME   "The handy education database"
#define COMMENT_VERSION_STRING "Version 1.3.3.4"	//-> 0.0.x.0 -> x should refer to the highest file version
#define COMMENT_AUTHORS        "Thomas Naeff"
//-------------------------------------------

//File extensions
#define	FILE_FORMULA_EXTENSION		"tfdb"
#define	FILE_TEXT_EXTENSION				"ttdb"
#define BACKUPFILE_NAME						"main\\thedbbck"
#define CONFIGURATION_FILE				"main\\thedbcnf"
#define CONF_FILE_EXTENSION				"conf"

//This string is displayed, when no file is selected
#define STR_NO_FILE_SEL		"No file selected "



//Identifiers
//------------
//Active form (Formula/Text/...)
#define	FORM_FORMULA		1
#define	FORM_TEXT				2

//Identifiers for the list view
#define		NAME			1
#define		FORMULA		2
#define		DESC			3

#define		TITLE			1
#define		TEXT			2

//Identifiers for the list view when copying or cutting data
//used with MarkedAction
#define		MA_COPY		1
#define		MA_CUT		2

//Identifiers for the settings
#define		S_STARTUP_LIST		1
#define		S_ARCHIVE_YES			1
#define		S_ARCHIVE_NO			0
#define		S_BACKUP_YES			1
#define		S_BACKUP_NO				0

//the lenght of a file path
#define		PATH_LENGHT		21

//The maximum lenght of the value for solving
#define MAXLEN_VALUE				30

//This string has to be enough long to handle the maximum of possible chars
//solve(   ...formula...    |   ...variable    =   value...       and ...variable=value...  ,  ...variable    )	  and 5 for security
//6      + MAXLEN_FORMULA + 1 + MAXLEN_VARS * (1 + MAXLEN_VALUE +  5  )                   + 1 + MAXLEN_VARS + 1 +     5
#define SOLVE_STRING_SIZE		6 + MAXLEN_FORMULA + 1 + (MAXLEN_VARS * (1 + MAXLEN_VALUE + 5)) + 1 + MAXLEN_VARS + 1 + 5



//Global variables
//------------------
char VarBuffer[20];
char ActivePath[PATH_LENGHT];

//Function prototypes
//--------------------
void main_menu (CONFSTRUCT *confstruct, int action);
int main_menu_control (CONFSTRUCT *confstruct, int *ActiveMenu, int *CursorPosY);
//void draw_main_background(void);
int new_entry_formula (CONFSTRUCT *confstruct, int action, int datanr);
int create_new_file (CONFSTRUCT *confstruct);
int list_data (CONFSTRUCT *confstruct);
void show_process_window (WINDOW **window, const char *infotext);
int chars_in_window_on_one_line (int WindowWidth, const char *string, unsigned int *NumOfChars);
int new_entry_text (CONFSTRUCT *confstruct, int action, int datanr);
int remove_entry (int datanr, const char *FilePath, int FileVersion, const char *FileExtension);
int search_entry (FILE **file, CONFSTRUCT *confstruct, int *start, int *Pos, int action);
void ShowVarLink (void);
int check_file_validity (CONFSTRUCT *confstruct, const char *filename, int option);
int check_if_file_is_locked (FILE *file);
int view2d (CONFSTRUCT *confstruct, FILE **datafile, const char *StrToDisplay, WINDOW *ListWindow, WIN_RECT *ListWinr, int *datanr, int *print_mode);
void copy_to_clipboard (CONFSTRUCT *confstruct, int datanr, const char *CopyToClipboardStr);
int process_vars (CONFSTRUCT *confstruct, WINDOW *ListWindow, WIN_RECT *ListWinr, int datanr, int *print_mode, int *key);
int read_vars_of_expr (const char *expr, char ListOfVars[MAXLEN_VARS]);
void choose_path (CONFSTRUCT *confstruct, char *Path);
int archive_active_file (CONFSTRUCT *confstruct);
int check_if_in_use_bit_set (int no_message);
int settings (CONFSTRUCT *confstruct, int *CursorPosY);
void main_menu_graphic (void);



