// C Source File
// Created 23.02.2006; 20:17:24

 /********************************************************************************
 ********************************************************************************
 * Programm name:		thedb - The handy education database
 * File name:				remove_entry.c
 * Function name:		remove_entry
 * Header file:			---
 * Other functions:
 *	-
 *
 * Short Description: Remove the entry selected in the list view
 *
 * Description:
 *	-
 *
 ********************************************************************************
 *********************************************************************************/

#include <tigcclib.h>
#include "fmanage.h"

#include "structures.h"
#include "global.h"
#include "calc.h"

int remove_entry (int datanr, const char *FilePath, int FileVersion, const char *FileExtension)
{
	FILE *datafile = NULL;						//The file pointer that handles the data file


	//Try to open the file. If it fails, create it.
	if ((fmanage(&datafile, FilePath, FileVersion, FileExtension, NULL, 0, 0, FMF_NEW_FILE, FMF_NEW_NO_OVERWR | FMF_NO_FINFO_CHECK)) < 0)
		{
			return -1;
		}

	if ((check_if_file_is_locked(datafile)) == -1)
		return -1;

		GrayOff();

		if ((DlgMessage("thedb[10]", "Remove this entry completely?", BT_OK, BT_CANCEL)) == KEY_ESC)
			{
				GrayOn();
				return -1;
			}


	WINDOW *window = NULL;
	show_process_window (&window, "Remove");

		//remove data
		if ((fmanage(&datafile, FilePath, FileVersion, FileExtension, NULL, 0, datanr, FMF_REMOVE, FMF_NO_FINFO_CHECK)) < 0)
			DlgMessage("thedb[11]", "Failed to remove!", BT_OK, BT_NONE);

	//Free the timer and the window created with show_process_window.
	OSVFreeTimer (1);
  WinClose (window);
  HeapFreePtr (window);


	GrayOn();
	return 0;

}