// C Source File
// Created 25.02.2006; 15:45:07

 /********************************************************************************
 ********************************************************************************
 * Programm name:		thedb - The handy education database
 * File name:				search_entry.c
 * Function name:		search_entry
 * Header file:			---
 * Other functions:
 *	- do_found
 *
 * Short Description: Search the list view, startin at the selected entry, for the
 *										existence of a part of a string
 *
 * Description:
 *	-
 *
 ********************************************************************************
 *********************************************************************************/

#include <tigcclib.h>
#include "fmanage.h"

#include "structures.h"
#include "global.h"
#include "calc.h"

//
int do_found (int SearchPos, int *start, int *Pos, long int NumOfBlocks);
//

#define UP		1
#define DOWN	2


int search_entry (FILE **file, CONFSTRUCT *confstruct, int *start, int *Pos, int action)
{
	HANDLE dialog;
	//HANDLE pdown;
	FORMULADATA formuladata;
	TEXTDATA textdata;

	int SearchPos = *start + *Pos - 1;
	int pdown_choice = DOWN;
	long int NumOfBlocks = 0;
	int found = 0;
	char SearchString[101] = {0};

	void *kbq = kbd_queue ();
	unsigned short key;

	//Load the number of blocks
	NumOfBlocks = fmanage(file, NULL, 0, NULL, NULL, 0, 0, FMF_RETURN_FINFO, FMF_RETURN_NOB);

	//Load one data block before the marked one.
	//After that, the filepointer will be at the right position.
	switch (confstruct->ActiveForm)
		{
			case FORM_FORMULA:
					fmanage(file, NULL, FMF_FORMULA_FILE_VERSION, FILE_FORMULA_EXTENSION, &formuladata, sizeof(FORMULADATA), SearchPos, FMF_LOAD, 0);
				break;
			case FORM_TEXT:
					fmanage(file, NULL, FMF_TEXT_FILE_VERSION, FILE_TEXT_EXTENSION, &textdata, sizeof(TEXTDATA), SearchPos, FMF_LOAD, 0);
				break;
			default:
				break;
		}


	dialog = DialogNewSimple (130, 50);
	//pdown = PopupNew ("" , 0);

	//Add the dialog title
	DialogAddTitle (dialog, "Search", BT_GOTO, BT_CANCEL);

	DialogAddText(dialog, 2, 15, "Search for:");
	DialogAddRequest(dialog, 3, 25, "", 0, 20, 18);

	//PopupAddText(pdown, -1, "Up", UP);
	//PopupAddText(pdown, -1, "Down", DOWN);
	//DialogAddPulldown(dialog, 2, 35, "Direction:", pdown, 0);



	GrayOff();

	//Don't show the dialog box, when F8 (2nd + F3) has been pressed.
	if (action == 0)
		{
			if ((DialogDo(dialog, CENTER, CENTER, confstruct->LastSearchString, &pdown_choice)) == KEY_ESC)
				{
					GrayOn();
					HeapFree(dialog);
					//HeapFree(pdown);
					return -1;

				}
		}

	ST_helpMsg("Searching... Please wait!");

	while (SearchPos < NumOfBlocks)
		{
			SearchPos++;

				//It would be nice to show the percent status of searching, but it makes the whole progress really slow!
				//sprintf(searchinfo, "Searching... %.1f%%", (double)(100 / (double)(NumOfBlocks - (*start + *Pos))) * (double)(SearchPos - (*start + *Pos)));
				//ST_helpMsg(searchinfo);

				switch (confstruct->ActiveForm)
					{
						case FORM_FORMULA:
								fread(&formuladata, sizeof(FORMULADATA), 1, *file);
								switch (confstruct->ActiveList)
									{
										case FORMULA:
												strcpy(SearchString, formuladata.formula);
											break;
										case DESC:
												strcpy(SearchString, formuladata.desc);
											break;
										default:	//NAME
												strcpy(SearchString, formuladata.name);
											break;
									}
							break;
						case FORM_TEXT:
								fread(&textdata, sizeof(TEXTDATA), 1, *file);
								switch (confstruct->ActiveList)
									{
										case TEXT:
												strcpy(SearchString, textdata.text);
											break;
										default:	//TITLE
												confstruct->ActiveList = TITLE;
												strcpy(SearchString, textdata.title);
											break;
									}
							break;
						default:
							break;
					}

			//Compare
			if (strstr(SearchString, confstruct->LastSearchString) != NULL)
				{
					if ((do_found(SearchPos, start, Pos, NumOfBlocks)) == 1)
						found = 2;
					else
						found = 1;
				}

			//Exit loop if found
			if (found > 0)
				break;

			//Exit copy when ESC was pressed
			if (!OSdequeue (&key, kbq))
				{
					if (key == KEY_ESC)
						{
							found = 3;
							break;
						}
				}

		};



	if (found == 0)
		{
			char str[50] = {0};
			sprintf(str, "Reached the end!\n"
										"\"%s\" not found!", confstruct->LastSearchString);
			DlgMessage("thedb[14]", str, BT_OK, BT_NONE);
		}
	else if (found == 3)
		{
			ST_helpMsg("...abort!");
		}
	else
		{
			ST_helpMsg("...found something");
		}

	GrayOn();
	HeapFree(dialog);
	//HeapFree(pdown);

	if (found == 2)
		return 0;	//-> Refresh the list, if the search string was found outside the current showed data
	else if (found == 1)
		return 1;
	else
		return -1;

}

//================================================================================

int do_found (int SearchPos, int *start, int *Pos, long int NumOfBlocks)
{
		//If the string was found within the current showed data
		if (SearchPos < *start + MAX_DISP_LINES)
			{
				//Just move the cursor block
				*Pos = SearchPos - (*start - 1);
			}
		else
			{
				//Otherwise let the cursor block on his place and change the start data
				*start = (SearchPos + 1) - MAX_DISP_LINES;
				*Pos = SearchPos - (*start - 1);

				//If the start data is not valid
				if ((*start + MAX_DISP_LINES) > NumOfBlocks)
					{;
						//Display the last data
						*start = NumOfBlocks - MAX_DISP_LINES + 1;
						//and set the position of the cursor block within the current showed data
						*Pos = SearchPos - (*start - 1);
					}
				return 1;
			}


	return 0;
}

//================================================================================


